<template>
	<mind-layout>
		<template slot="toolbar-actions">
			<el-radio-group v-model="rawMode"  size="small" style="margin-right: 20px; margin-bottom: 2px">
				<el-radio-button  :label="false"  title="Modo Formulario"><i class="el-icon-edit-outline"></i></el-radio-button>
				<el-radio-button :label="true" title="Modo RAW"><i class="el-icon-tickets" /></el-radio-button>
			</el-radio-group>
			<el-button type="primary" size="small" @click="onSubmit">Aplicar</el-button>
		</template>
		<mind-form :footer="false">
			<el-row wrap>
				<el-col :xs="24" :lg="12" :xl="8">
					<el-form-item  label="Extensión">
						<el-input v-model="recurso.category"></el-input>
					</el-form-item>
				</el-col>
			</el-row>
			<asterisk-context :mode="rawMode ? 'raw' : 'custom'" v-model="trunkData" :mnemonics="mnemonics" >
				<template v-slot="{context}">
					<el-row wrap >
						<el-col :xs="24" :lg="12" :xl="8">
							<el-form-item  label="Nombre">
								<el-input  v-model="context.fullname"/>
							</el-form-item>
						</el-col>
						<el-col :xs="24" :lg="12" :xl="8">
							<el-form-item  label="CallerID">
								<el-input  v-model="context.cid_number"/>
							</el-form-item>
						</el-col>
						<el-col :xs="24" :lg="12" :xl="8">
							<el-form-item  label="Contexto">
								<select-context v-model="context.context" filter="dial-"/>
								<!--<el-input  v-model="context.context"></el-input>-->
							</el-form-item>
						</el-col>
						<el-col :xs="24" :lg="12" :xl="8">
							<el-form-item  label="IP">
								<el-input  v-model="context.host"></el-input>
							</el-form-item>
						</el-col>
					</el-row>
					<el-row>
						<el-col :xs="24" :lg="12" :xl="8">
							<el-form-item  label="SIP">
								<el-radio-group v-model="context.hassip"  size="small" >
									<el-radio-button  label="yes"  >Si</el-radio-button>
									<el-radio-button label="no" >No</el-radio-button>
								</el-radio-group>
							</el-form-item>
						</el-col>
						<el-col :xs="24" :lg="12" :xl="8">
							<el-form-item  label="IAX">
								<el-radio-group v-model="context.hasiax"  size="small" >
									<el-radio-button  label="yes"  >Si</el-radio-button>
									<el-radio-button label="no" >No</el-radio-button>
								</el-radio-group>
							</el-form-item>
						</el-col>
						<el-col :xs="24" :lg="12" :xl="8">
							<el-form-item  label="Llamada en Espera">
								<el-radio-group v-model="context.callwaiting"  size="small" >
									<el-radio-button  label="yes"  >Si</el-radio-button>
									<el-radio-button label="no" >No</el-radio-button>
								</el-radio-group>
							</el-form-item>
						</el-col>
						<el-col :xs="24" :lg="12" :xl="8">
							<el-form-item  label="Conferencia">
								<el-radio-group v-model="context.threewaycalling"  size="small" >
									<el-radio-button  label="yes"  >Si</el-radio-button>
									<el-radio-button label="no" >No</el-radio-button>
								</el-radio-group>
							</el-form-item>
						</el-col>
						<el-col :xs="24" :lg="12" :xl="8">
							<el-form-item  label="Es Agente">
								<el-radio-group v-model="context.hasagent"  size="small" >
									<el-radio-button  label="yes"  >Si</el-radio-button>
									<el-radio-button label="no" >No</el-radio-button>
								</el-radio-group>
							</el-form-item>
						</el-col>
						<el-col :xs="24" :lg="12" :xl="8">
							<el-form-item  label="Directorio">
								<el-radio-group v-model="context.hasdirectory"  size="small" >
									<el-radio-button  label="yes"  >Si</el-radio-button>
									<el-radio-button label="no" >No</el-radio-button>
								</el-radio-group>
							</el-form-item>
						</el-col>
						<el-col :xs="24" :lg="12" :xl="8">
							<el-form-item  label="Voice Mail">
								<el-radio-group v-model="context.hasvoicemail"  size="small" >
									<el-radio-button  label="yes"  >Si</el-radio-button>
									<el-radio-button label="no" >No</el-radio-button>
								</el-radio-group>
							</el-form-item>
						</el-col>
						<el-col :xs="24" :lg="12" :xl="8">
							<el-form-item  label="Borrar Voice Mail">
								<el-radio-group v-model="context.deletevoicemail"  size="small" >
									<el-radio-button  label="yes"  >Si</el-radio-button>
									<el-radio-button label="no" >No</el-radio-button>
								</el-radio-group>
							</el-form-item>
						</el-col>
						<el-col :xs="24" :lg="12" :xl="8">
							<el-form-item  label="Auto Provisión">
								<el-radio-group v-model="context.autoprov"  size="small" >
									<el-radio-button  label="yes"  >Si</el-radio-button>
									<el-radio-button label="no" >No</el-radio-button>
								</el-radio-group>
							</el-form-item>
						</el-col>
						<el-col :xs="24" :lg="12" :xl="8">
							<el-form-item  label="Perfil Autoprov">
								<el-input  v-model="context.profile"></el-input>
							</el-form-item>
						</el-col>
						<el-col :xs="24" :lg="12" :xl="8">
							<el-form-item  label="MAC Address">
								<el-input  v-model="context.macaddress"></el-input>
							</el-form-item>
						</el-col>
					</el-row>
					<el-divider>Autenticación</el-divider>
					<el-row>
						<el-col :xs="24" :lg="12" :xl="8">
							<el-form-item  label="Contraseña">
								<el-input type="password" v-model="context.secret"/>
							</el-form-item>
						</el-col>
					</el-row>
					<el-divider>Avanzado</el-divider>
					<template >
						<el-row >
							<el-col :xs="24" :lg="12" :xl="8">
								<el-form-item  label="Qualify">
									<el-radio-group v-model="context.qualify"  size="small" >
										<el-radio-button  label="yes"  >Si</el-radio-button>
										<el-radio-button label="no" >No</el-radio-button>
									</el-radio-group>
								</el-form-item>
							</el-col>
							<el-col :xs="24" :lg="12" :xl="8">
								<el-form-item  label="NAT">
									<el-radio-group v-model="context.nat"  size="small" >
										<el-radio-button  label="yes"  >Si</el-radio-button>
										<el-radio-button label="no" >No</el-radio-button>
										<el-radio-button label="force_rport" >force_rport</el-radio-button>
										<el-radio-button label="comedia" >comedia</el-radio-button>
									</el-radio-group>
								</el-form-item>
							</el-col>
							<el-col :xs="24" :lg="12" :xl="8">
								<el-form-item  label="Direct Media">
									<el-radio-group v-model="context.directmedia"  size="small" >
										<el-radio-button  label="yes"  >Si</el-radio-button>
										<el-radio-button label="no" >No</el-radio-button>
									</el-radio-group>
								</el-form-item>
							</el-col>
							<el-col :xs="24" :lg="12" :xl="8">
								<el-form-item  label="Modo DTMF">
									<el-radio-group v-model="context.dtmfmode" size="small" >
										<el-radio-button  label="info"  >info</el-radio-button>
										<el-radio-button label="inband" >inband</el-radio-button>
										<el-radio-button label="rfc2833" >rfc2833</el-radio-button>
									</el-radio-group>
								</el-form-item>
							</el-col>
							<el-col :xs="24" :lg="12" :xl="8">
								<el-form-item  label="Codecs">
									<select-codec v-model="context.allow" />
								</el-form-item>
							</el-col>
							<el-col :xs="24" :lg="12" :xl="8">
								<el-form-item  label="Transporte">
									<el-select v-model="context.transport" > 
										<el-option 
											label="tcp"
											value="tcp" />
										<el-option
											label="udp"
											value="udp" />
									</el-select>
									<!-- <el-input disabled autosize v-model="recurso.type"></el-input> -->
								</el-form-item>
							</el-col>

						</el-row>
					</template>

				</template>
			</asterisk-context>
		</mind-form>
	</mind-layout>
</template>
<script>
import {Rest} from '@/../modules/mind-core-vue'
import asteriskContext from '@/components/asterisk-context'
import mnemonics from '@/mnemonics/sip-trunk'
import selectCodec from '@/components/select-codec'
import selectContext from '@/components/select-context'
// import selectAuth from '@/components/select-authtype'
// import inputArray from '@/components/input-array'

export default {
	components: {
		asteriskContext,
		selectCodec,
		selectContext
		// inputArselectContextray,
		// selectAuth
	},
	async created(){
		let id = this.$route.params.id
		this.api = new Rest({
			uri: `api/ami/users`, 
			key: 'name'
		})

		this.trunkName = id
		if(!id || id == 'new') {
			this.isNew = true
			this.recurso = {	}
		} else {
			const recurso = await this.api.Fetch(id)
			.catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});
			})
			this.recurso = recurso
		}
	},
	computed:{
		trunkData:{
			get(){
				return this.recurso.options || []
			},
			set(v) {
				this.recurso.options = v
			}
		},
		mnemonics() {
			return mnemonics
		}
	},

	methods: {
		async onSubmit() {
			if(this.isNew) {
				this.api.Post(this.recurso)
					.then(()=>{
						this.$message({
							showClose: true,
							type: 'success',
							message: "Usuario creado"
						});
					})
					.catch((error)=>{
						this.$message({
							showClose: true,
							type: 'error',
							message: error
						});
					})

			} else {
				this.api.Patch(this.recurso, this.trunkName)
					.then(()=>{
						this.$message({
							showClose: true,
							type: 'success',
							message: "Se aplicaron los cambios"
						});
					})
					.catch((error)=>{
						this.$message({
							showClose: true,
							type: 'error',
							message: error
						});
					})

			}
		}
	},
	filters: {
		join(v) {
			if(Array.isArray(v)) {
				return v.join(', ')
			}
			return v
		}
	},
	data() {
		return {
			isNew: false,
			recurso: {
			},
			api: null,
			trunkName: null,
			rawMode: false
		}
	}
}
</script>
<style lang="css" >
.el-select {
	width:100%;
}
</style>